;**************************************************************************
;   TRANSMISSOR  RF PARA CONTROLE REMOTOS ON/OFF 8 CANAIS SIMULANDO HT640
; 
;   PARA TRANSMISSO UTILIZA UM PIC 16F628A
;   BLOG: 'LARIOS.TECNOLOGIA.WS'
;
;   CLAUDIO LRIOS        INICIO: 05-08-2012  TERMINO:05-08-2012
;   ATUALIZAO
;	DEIVID FLORIANI  	  INICIO: 27-04-2013  TERMINO:27-04-2013	
;**************************************************************************
;  APLICAO: CONTROLAR BRINQUEDOS OU APLICAES A DISTANCIA
;   TRABALHA EM CONJUNTO COM O RX DE CDIGO ASM: Resc_RX_ASM
;  UTILIZE TX + RX NA FREQUENCIA DE 27MHZ (OPCIONALMENTE 49 MHZ)
;  PROTOCOLO:  1 STARTBIT + 1 BYTE (N. DO APARELHO) + 1 BYTE (BOTES) + TEMPO ENTRE TRANSMISSES
;*************************************************************************** 

#INCLUDE <P16F628A.INC>	;ARQUIVO PADRO MICROCHIP PARA 16F628A
__CONFIG  _BODEN_ON & _CP_OFF & _PWRTE_ON & _WDT_OFF & _LVP_OFF & _DATA_CP_OFF & _MCLRE_OFF & _INTRC_OSC_NOCLKOUT

;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                    PAGINAO DE MEMRIA                         *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;DEFINIO DE COMANDOS DE USURIO PARA ALTERAO DA PGINA DE MEMRIA

#DEFINE	BANK0	BCF STATUS,RP0	;SETA BANK 0 DE MEMRIA
#DEFINE	BANK1	BSF STATUS,RP0	;SETA BANK 1 DE MAMRIA

;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                         VARIVEIS                               *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; DEFINIO DOS NOMES E ENDEREOS DE TODAS AS VARIVEIS UTILIZADAS 
; PELO SISTEMA

	CBLOCK	0x20	;ENDEREO INICIAL DA MEMRIA DE USURIO
    RES1
    RES0
    R6
    R5
    R7
	TEMPO1
	TEMPO2
	INFORMA
	ENDC			;FIM DO BLOCO DE MEMRIA		

;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                        FLAGS INTERNOS                           *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; DEFINIO DE TODOS OS FLAGS UTILIZADOS PELO SISTEMA





;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                         CONSTANTES                              *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; DEFINIO DE TODAS AS CONSTANTES UTILIZADAS PELO SISTEMA



QBYTE   EQU  .16        ;QUANTIDADE DE BYTES A SER RECEBIDO 


;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                           ENTRADAS                              *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; DEFINIO DE TODOS OS PINOS QUE SERO UTILIZADOS COMO ENTRADA
; RECOMENDAMOS TAMBM COMENTAR O SIGNIFICADO DE SEUS ESTADOS (0 E 1)

#DEFINE 	CHAVE1		PORTA,6		  ;BOTO PARA ESCOLHA DE CDIGO



;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                           SADAS                                *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; DEFINIO DE TODOS OS PINOS QUE SERO UTILIZADOS COMO SADA
; RECOMENDAMOS TAMBM COMENTAR O SIGNIFICADO DE SEUS ESTADOS (0 E 1)

#DEFINE 	OUT 	PORTA,0  		 ;PINO 17  IN RF
#DEFINE		LED1	PORTA,1			 ;LED INDICA PRIMEIRO CDIGO	
#DEFINE		LED2	PORTA,2			 ;LED INDICA SEGUNDO  CDIGO	
#DEFINE		LED3	PORTA,3			 ;LED INDICA TERCEIRO CDIGO	

				
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                       VETOR DE RESET                            *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	ORG	0x00		;ENDEREO INICIAL DE PROCESSAMENTO
	GOTO	INICIO  ;DESVIA PARA O INCIO



	
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                    INCIO DA INTERRUPO                        *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; AS INTERRUPES NO SERO UTILIZADAS, POR ISSO PODEMOS SUBSTITUIR
; TODO O SISTEMA EXISTENTE NO ARQUIVO MODELO PELO APRESENTADO ABAIXO
; ESTE SISTEMA NO  OBRIGATRIO, MAS PODE EVITAR PROBLEMAS FUTUROS

	ORG	0x04		;ENDEREO INICIAL DA INTERRUPO
	RETFIE

;*********************************************************************************
;
;						TRATAMENTO DA INTERRUPO
;
;*********************************************************************************
	


;***********************************************************************
;		FIM DA INTERRUPO
;***********************************************************************



	;RETORNA DA INTERRUPO


;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                     INICIO DO PROGRAMA                          *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	
INICIO
	CLRF	PORTA		;LIMPA O PORTA
	CLRF	PORTB		;LIMPA O PORTB

	BANK1

	MOVLW  	B'00001000' 	;DETERMINA A FREQNCIA DO OSCILADOR INTERNO PARA 4MHZ
	MOVWF   PCON

	MOVLW	B'01000000'
	MOVWF	TRISA						
	MOVLW	B'11111111'
	MOVWF	TRISB		
	MOVLW	B'00000000'
	MOVWF	OPTION_REG	
	MOVLW	B'00000000'
	MOVWF	INTCON		;TODAS AS INTERRUPES DESLIGADAS
	
	BANK0				;RETORNA PARA O BANCO 0
	
	MOVLW	B'00000111'
	MOVWF	CMCON		;DESLIGA COMPARADORES


;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                     INICIALIZAO DAS VARIVEIS                 *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	CLRF	INFORMA
	MOVLW  	.170      ;CDIGO INICIAL DO TX
    MOVWF  	INFORMA
	BSF		LED1      ;LED REFERENTE AO CDIGO1

;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                     ROTINA PRINCIPAL                            *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

MAIN 
;=============================
	MOVFW   INFORMA
	MOVWF	RES0
    MOVFW 	PORTB     ;PEGA INFORMAO DAS TECLAS
    XORLW  	.255
    BTFSC  	STATUS,Z
    GOTO   	TESTE    ;AGUARDA ALGUMA TECLA SER APERTADA
    MOVFW 	PORTB
    MOVWF  	RES1

ENVIAR:
;-----------------------------------------------------
PAUSA:
	MOVLW 	.23		;23 UNIDADES BASICAS DE BIT
	MOVWF  	R6
RTY:
	CALL 	DELAY1CK
	DECFSZ 	R6,F
	GOTO 	RTY

;----------------------------------------------------
	CALL 	STARTBIT
;----------------------------------------------------
    MOVLW 	QBYTE  ;QUANTIDADE DE BITS A TRANSMITIR
    MOVWF  	R5
VOLT10:
    BCF 	STATUS,C
    RRF 	RES1,F
    RRF 	RES0,F
    BTFSC 	STATUS,C
    GOTO 	EB1
    CALL	BIT0
VV13:
    DECFSZ 	R5,F
	GOTO 	VOLT10


	GOTO 	MAIN
;-------------------------------------------------
EB1:
	CALL 	BIT1
	GOTO 	VV13
;=================================================
;ROTINAS

DELAY1CK:
	MOVLW  .120
    MOVWF 	R7  ;158D PARA 330 MICROSEG. DE LAMBDA
    DECFSZ 	R7,F
    GOTO  	$-1
    RETURN
BIT0:
	BCF 	OUT
	CALL 	DELAY1CK
	BSF 	OUT
	CALL 	DELAY1CK
	CALL 	DELAY1CK
	BCF 	OUT
    RETURN
BIT1:
	BCF 	OUT
	CALL 	DELAY1CK
	CALL 	DELAY1CK
	BSF 	OUT
	CALL 	DELAY1CK
	BCF 	OUT
    RETURN
STARTBIT:
	BSF 	OUT
	CALL 	DELAY1CK
	BCF 	OUT
	RETURN

TESTE
	CALL 	DELAY_CHAVE
VERIFICA1
    BTFSS 	CHAVE1
	GOTO 	MAIN
	DECFSZ 	TEMPO1,F
	GOTO 	VERIFICA1
	DECFSZ 	TEMPO2,F
	GOTO 	VERIFICA1
CODIGO1
	BTFSS	LED1
	GOTO	CODIGO2
	BCF		LED1
	BSF		LED2
	CLRF	INFORMA
	MOVLW	.169	
	MOVWF	INFORMA
	GOTO	TRAVA
CODIGO2
	BTFSS	LED2
	GOTO	CODIGO3
	BCF		LED2
	BSF		LED3
	CLRF	INFORMA
	MOVLW	.168	
	MOVWF	INFORMA
	GOTO	TRAVA
CODIGO3
	BTFSS	LED3
	GOTO	MAIN
	BCF		LED3
	BSF		LED1
	CLRF	INFORMA
	MOVLW	.170	
	MOVWF	INFORMA
	GOTO	TRAVA
TRAVA
	BTFSS	CHAVE1
	GOTO	MAIN	
	GOTO	TRAVA

DELAY_CHAVE		  ;DELAY DE SEGURANA PARA EVITAR QUE UM RUDO ACIONE A TECLA = DELAY DE 80MS	
	CLRF 	TEMPO1
	CLRF 	TEMPO2
	MOVLW 	.50
	MOVWF 	TEMPO1
	MOVLW 	.100
	MOVWF 	TEMPO2
	RETURN




;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                       FIM DO PROGRAMA                           *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	END			;OBRIGATRIO
